###############Not for R!!!#############
# #1fastq file
sample.fastq

# #2fastq file seq only
seq.txt

#match #1 into PCRE
^((?!@).).+(GATC)+.+$

#match #1&#2 into R
.+(GATC).+

#description file
^([a-zA-Z]+)\.([a-zA-Z0-9]+)\.([a-zA-Z0-9_]+)\.([0-9]+)[[:space:]](.+)(\.fastq\.gz)
#For R
^([a-zA-Z]+)\\.([a-zA-Z0-9]+)\\.([a-zA-Z0-9_]+)\\.([0-9]+)
(.+)(\\.fastq\\.gz)

###############Not for R!!!#############
rm(list=ls())
source("http://bioconductor.org/biocLite.R")
biocLite("ShortRead")
library(ShortRead)
sample <- readFastq(getwd(), pattern="sample.fastq")
str(sample)
length(sample@sread)

a <- as.character(sample@sread)
writeLines(a, con = "seq.txt", sep = "\n", useBytes = FALSE)

#
grep("GATC", sample@sread, perl=TRUE, value=TRUE)
grep("GATC", sample@sread, perl=TRUE, value=FALSE)

grepl("GATC", sample@sread, perl=TRUE)

regexpr("GATC", sample@sread, perl=TRUE)
regmatches(sample@sread, regexpr("GATC", sample@sread, perl=TRUE))

gregexpr("GATC", sample@sread, perl=TRUE)
regmatches(sample@sread, gregexpr("GATC", sample@sread, perl=TRUE))

#
sub("GATC", " empty_string ", sample@sread, perl=TRUE)
gsub("GATC", " empty_string ", sample@sread, perl=TRUE)

#  
grep("^GATC", sample@sread, perl=TRUE, value=TRUE)
grep("GATC$", sample@sread, perl=TRUE, value=TRUE)

#GATC   
grep("^(GATC).+(GATC)$", sample@sread, perl=TRUE, value=TRUE)

#  GATC,  e
grep("(.*GATC.*){2}", sample@sread, perl=TRUE, value=TRUE)
grepl("(.*GATC.*){2}", sample@sread, perl=TRUE)

#  GATC 
grep(".+(GATC).+", sample@sread, perl=TRUE, value=FALSE)

#  GATC,     .
select <- grep("(.*)([ATGC]{2})(GATC)([ATGC]{6})(.*)", sample@sread, perl=TRUE, value=TRUE)
sub("(.*)([ATGC]{2})(GATC)([ATGC]{6})(.*)", "\\2\\3\\4", select, perl=TRUE)

#   
gatc <- "(.*)([ATGC]{2})(GATC)([ATGC]{6})(.*)"
grep(gatc, sample@sread, perl=TRUE, value=TRUE)

a <- "GATC"
gatc <- paste("(.*)([ATGC]{2})(", a, ")([ATGC]{6})(.*)", sep="")
grep(gatc, sample@sread, perl=TRUE, value=TRUE)

a <- "TATA"
gatc <- paste("(.*)([ATGC]{2})(", a, ")([ATGC]{6})(.*)", sep="")
grep(gatc, sample@sread, perl=TRUE, value=TRUE)

# 
damid <-  read.delim("description.txt", header=T, sep=" ")

grep("^([a-zA-Z]+)\\.([a-zA-Z0-9]+)\\.([a-zA-Z0-9_]+)\\.([0-9]+)", damid$Data.set, perl=TRUE, value=TRUE)
grep("(.+)(\\.fastq\\.gz)", damid$fastq.file, perl=TRUE, value=TRUE)

fin <- as.data.frame(matrix(data=NA, nrow=nrow(source), ncol=6, dimnames=NULL))
ins <- "_inner"
names(fin) <- c("id", "tissue", "protein", "conditions", "replicate", "path")

fin$path <- gsub("(.+)(\\.fastq\\.gz)", paste("\\1", ins, "_local_GATCcounts.RData", sep=""), damid$fastq.file, perl=TRUE)

for (name in names(fin)[1:5]){
colnumber <- which( colnames(fin)==name ) # grep(name, colnames(fin))
if (colnumber == 1){
subst <- paste("\\1\\.\\2\\.\\3", ins, "\\.\\4", sep="")
} else if (colnumber %in% c(2,3,5)){
subst <- paste("\\", colnumber - 1, sep="")
} else {
subst <- paste("\\3", ins, sep="")
}

fin[[name]] <- gsub("^([a-zA-Z]+)\\.([a-zA-Z0-9]+)\\.([a-zA-Z0-9_]+)\\.([0-9]+)", subst, damid$Data.set, perl=TRUE)
}

write.table(fin, file="rdata_description.csv", sep=";", row.names=F, col.names=T, quote=F, dec=".", append=F)
